package com.project.contact;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.URI;
import java.net.URISyntaxException;
import java.util.Vector;

import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.utils.URLEncodedUtils;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;

import android.app.Activity;
import android.app.ProgressDialog;
import android.os.Bundle;
import android.os.Handler;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

public class EditInfo extends Activity implements OnClickListener{
	EditText fname;
	EditText lname;
	EditText mobile;
	EditText phone;
	EditText email;
	EditText address;
	EditText suburb;
	EditText state;
	EditText code;
	EditText country;
	
	Button add;
	Button cancel;
	
	ProgressDialog dialog;

	String fn;
	String ln;
	String em;
	String mo;
	String pn;
	String ad;
	String st;
	String cd;
	String cn;
	String sb;
	
	Boolean status = false;
	Handler handler = new Handler();
	Thread th_edit;
	Toast toast;
	//newcontact and preload all the data in edittexts
	/** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.newcontact);
        
        fname = (EditText)findViewById(R.id.fname);
        lname = (EditText)findViewById(R.id.lname);
        mobile = (EditText)findViewById(R.id.mobile);
        phone = (EditText)findViewById(R.id.phone);
        email = (EditText)findViewById(R.id.email);
        address = (EditText)findViewById(R.id.address);
        suburb = (EditText)findViewById(R.id.suburb);
        state = (EditText)findViewById(R.id.state);
        code = (EditText)findViewById(R.id.code);
        country = (EditText)findViewById(R.id.country);
        
        fname.setText(ViewInfo.conta.GetFname());
        lname.setText(ViewInfo.conta.GetLname());
        mobile.setText(ViewInfo.conta.GetMobile());
        phone.setText(ViewInfo.conta.GetPhone());
        email.setText(ViewInfo.conta.GetMail());
        address.setText(ViewInfo.conta.GetAddress());
        suburb.setText(ViewInfo.conta.GetSuburb());
        state.setText(ViewInfo.conta.GetState());
        code.setText(ViewInfo.conta.GetCode());
        country.setText(ViewInfo.conta.GetCountry());
        /*
        fname.setText(Screen1.contacts.get(Screen1.clicked).GetFname());
        lname.setText(Screen1.contacts.get(Screen1.clicked).GetLname());
        mobile.setText(Screen1.contacts.get(Screen1.clicked).GetMobile());
        phone.setText(Screen1.contacts.get(Screen1.clicked).GetPhone());
        email.setText(Screen1.contacts.get(Screen1.clicked).GetMail());
        address.setText(Screen1.contacts.get(Screen1.clicked).GetAddress());
        suburb.setText(Screen1.contacts.get(Screen1.clicked).GetSuburb());
        state.setText(Screen1.contacts.get(Screen1.clicked).GetState());
        code.setText(Screen1.contacts.get(Screen1.clicked).GetCode());
        country.setText(Screen1.contacts.get(Screen1.clicked).GetCountry());
        */
        add = (Button)findViewById(R.id.add);
        cancel = (Button)findViewById(R.id.cancel);
        
        toast = Toast.makeText(this,"",Toast.LENGTH_SHORT);
        th_edit = new Thread(null,UpdatePerson,"Person_Update");
        dialog = new ProgressDialog(this);
        dialog.setMessage("Please wait..");
        add.setText("Edit");
        add.setOnClickListener(this);
        cancel.setOnClickListener(this);
    }
    
    @Override
    public void onStart(){
    	super.onStart();
    }
    
    private Runnable UpdatePerson = new Runnable(){
    	public void run(){
    		handler.post(UpdateUI);
    		EditInformation();
    		handler.post(UpdateUI);
    	}
    };
    private Runnable UpdateUI = new Runnable(){
    	public void run(){
    		if(dialog.isShowing()){
    			if(status){toast.setText("Edit information successful!");
    			toast.show();
    			}
    			else {
    				toast.setText("Try again Later!");
        			toast.show();
    			}
    			dialog.dismiss();
    		}
    		else dialog.show();
    	}
    };
    public void EditInformation(){
    	String urlstr = "https://secure.mydigitalspacelive.com/directory/ondemand/object.asp?method=PERSON_UPDATE&"; 
		//"https://secure.mydigitalspacelive.com/directory/ondemand/logon.asp?logon=";
    	Vector<NameValuePair> vars = new Vector<NameValuePair>();
    	vars.add(new BasicNameValuePair("sid",MainActivity.sid));
    	vars.add(new BasicNameValuePair("select",ViewInfo.conta.GetId()));
    	vars.add(new BasicNameValuePair("firstname",fn));
    	vars.add(new BasicNameValuePair("surname",ln));
    	vars.add(new BasicNameValuePair("phone",pn));
    	vars.add(new BasicNameValuePair("mobile",mo));
    	vars.add(new BasicNameValuePair("email",em));
    	vars.add(new BasicNameValuePair("streetaddress1",ad));
    	vars.add(new BasicNameValuePair("streetsuburb",sb));
    	vars.add(new BasicNameValuePair("streetstate",st));
    	vars.add(new BasicNameValuePair("streetpostcode",cd));
    	vars.add(new BasicNameValuePair("streetcountry",cn));

    	HttpGet method;
    	BufferedReader in = null;

    	try {
    		URI url = new URI(urlstr + URLEncodedUtils.format(vars,null));
    		HttpClient client = new DefaultHttpClient();
    		method = new HttpGet(url);
    		
    		HttpResponse response = client.execute(method);
    		in = new BufferedReader 
				(new InputStreamReader(response.getEntity().getContent() ));
    		//TODO: retrieve the response and prompt user via Toast
    		String str="";
    		while(in.readLine()==null){
    			str+=in.readLine();
    			if(str.substring(0, 1).equals("OK"))
    				status = true;
    		}
    	}catch(ClientProtocolException e){
    		Log.e("ClientProtocolException","Error Occured in fetching videos!" + e.getMessage());
    		e.printStackTrace();
    	}catch(IOException e){
    		Log.e("IOException","Error Occured in fetching videos!"+ e.getMessage());
    		e.printStackTrace();
    	}catch(URISyntaxException e){
    		Log.e("URISyntaxException","Error Occured in fetching videos!"+ e.getMessage());
    		e.printStackTrace();
    	}
    }
    
    public void onClick(View v) {
    	if(v==add){
			fn = fname.getText().toString();
			ln = lname.getText().toString();
			em = email.getText().toString();
			mo = mobile.getText().toString();
			pn = phone.getText().toString();
			ad = address.getText().toString();
			st = state.getText().toString();
			cd = code.getText().toString();
			cn = country.getText().toString();
			sb = suburb.getText().toString();
			/*
			Screen1.contacts.get(Screen1.clicked).SetAddress(ad);
			Screen1.contacts.get(Screen1.clicked).SetFname(fn);
			Screen1.contacts.get(Screen1.clicked).SetLname(ln);
			Screen1.contacts.get(Screen1.clicked).SetMail(em);
			Screen1.contacts.get(Screen1.clicked).SetMobile(mo);
			Screen1.contacts.get(Screen1.clicked).SetPhone(pn);
			Screen1.contacts.get(Screen1.clicked).SetState(st);
			Screen1.contacts.get(Screen1.clicked).SetCode(cd);
			Screen1.contacts.get(Screen1.clicked).SetCountry(cn);
			Screen1.contacts.get(Screen1.clicked).SetSuburb(sb);
			*/
			th_edit = new Thread(null,UpdatePerson,"Person_Update");
			th_edit.start();
			this.finish();
		}
		else 
			this.finish();
	}
}

