package com.project.contact;

import java.util.ArrayList;
import android.app.Activity;
import android.app.Dialog;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.ImageButton;
import android.widget.ListView;
import android.widget.TextView;

public class Screen1 extends Activity implements OnClickListener,OnItemClickListener{
	
	ListView lv1;
	ListView lv2;
	
	public static Boolean fvt = false;
	Boolean setQuit = false;
	Boolean favor = false;
	public static int clicked = 0;
	ArrayList<String> alphabet;
	char[] a = {'a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z'};
	public static ContactList contacts;
	Button add;
	ImageButton refresh;
	ContactAdapter ca;
	ProgressDialog dialog;
	Handler handler = new Handler();
	/** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
    	super.onCreate(savedInstanceState);
        setContentView(R.layout.screen1);
        
        //ArrayList<Contact> arr = savedInstanceState.getParcelableArrayList("Contacts");
        Bundle b = getIntent().getExtras();
        contacts = b.getParcelable("Contacts");
        add = (Button)findViewById(R.id.add);
        refresh = (ImageButton)findViewById(R.id.refresh);
        
        //contacts = new ContactList();
        add.setOnClickListener(this);
        refresh.setOnClickListener(this);
        
        lv1 = (ListView)findViewById(R.id.list1);
        lv2 = (ListView)findViewById(R.id.list2);
        
        //Contact fk1 = new Contact("qweq","qwrewr","","","","'","","","","");
		//Screen1.contacts.add(fk1);
		//Contact fk2 = new Contact("qasda","adadad","","","","'","","","","");
		//Screen1.contacts.add(fk2);
		//Contact fk3 = new Contact("Hassan","Jawed","","","","'","","","","");
		//Screen1.contacts.add(fk3);
        alphabet = new ArrayList<String>();
        dialog = new ProgressDialog(this);
        dialog.setMessage("Loading, please wait..");
        
        //contacts = MainActivity.cont;
    	ParseList();
        ca = new ContactAdapter(this,R.layout.launch,contacts);
        lv2.setAdapter(ca);
        lv2.setOnItemClickListener(this);
        lv1.setOnItemClickListener(this);
    }
    
    @Override
    public void onStart(){
    	final Dialog dial = new Dialog(this);
   	 dial.setTitle("Log Off");
   	 dial.setContentView(R.layout.launch);
   	 Button yes = (Button)dial.findViewById(R.id.yes);
   	 yes.setOnClickListener(new View.OnClickListener() {
		
		public void onClick(View v) {
			// TODO Auto-generated method stub
			dial.dismiss();
			setQuit = true;
		}});
   	Button no = (Button)dial.findViewById(R.id.no);
  	 no.setOnClickListener(new View.OnClickListener() {
		
		public void onClick(View v) {
			// TODO Auto-generated method stub
			dial.dismiss();
		}});
	
    	super.onStart();
    }
    
    @Override
    public void onResume(){
    	if(setQuit) this.finish();
    	super.onResume();
    }/*
    private Runnable Down = new Runnable(){
    	public void run(){
    		
    	}
    };
    private Runnable UpdateUI = new Runnable(){
    	public void run(){
    		if(dialog.isShowing()) {
    			dialog.dismiss();
    		}
    		else dialog.show();
    	}
    };*/
    private class ContactAdapter extends ArrayAdapter{
    	ContactList items;
    	TextView txt;
    	TextView txt2;
		@SuppressWarnings("unchecked")
		public ContactAdapter(Context context, int resource,
				 ContactList objects) {
			super(context, resource,objects);
			// TODO Auto-generated constructor stub
			items = objects;
		}
    	
		@Override
		public View getView(int position,View convertView,ViewGroup parentView){
			if(convertView==null){
				LayoutInflater li = (LayoutInflater)getSystemService(Context.LAYOUT_INFLATER_SERVICE);
				convertView = li.inflate(R.layout.row, null);
				
				if((items.get(position).GetFname().equals(""))||(items.get(position).GetFname().length()==1)){					
						convertView = li.inflate(R.layout.row2, null);
						txt = (TextView)convertView.findViewById(R.id.atxt);
						txt.setText(contacts.get(position).GetFname());
				}
				else{
					txt = (TextView)convertView.findViewById(R.id.fnametxt);
					txt2 = (TextView)convertView.findViewById(R.id.lnametxt);
					txt.setText(items.get(position).GetFname()+"  ");
					txt2.setText(items.get(position).GetLname());
				}
			}
			else{
				if (items.get(position).GetFname().equals("") || (items.get(position).GetFname().length()==1)){
					LayoutInflater li = (LayoutInflater)getSystemService(Context.LAYOUT_INFLATER_SERVICE);
					convertView = li.inflate(R.layout.row2, null);
					txt = (TextView)convertView.findViewById(R.id.atxt);
					txt.setText(contacts.get(position).GetFname());
				}
				else{
				LayoutInflater li = (LayoutInflater)getSystemService(Context.LAYOUT_INFLATER_SERVICE);
				convertView = li.inflate(R.layout.row, null);
				txt = (TextView)convertView.findViewById(R.id.fnametxt);
				txt2 = (TextView)convertView.findViewById(R.id.lnametxt);
				txt.setText(items.get(position).GetFname()+"  ");
				txt2.setText(items.get(position).GetLname());
				}
			}
			return convertView;
		}
    }
    
    /*
    private class ContactAdapter extends ArrayAdapter<Contact>{
    	ArrayList<Contact> items;
    	int layout;
    	TextView tfname;
    	TextView tlname;
		public ContactAdapter(Context context, int textViewResourceId,
				ArrayList<Contact> objects) {
			super(context, textViewResourceId, objects);
			// TODO Auto-generated constructor stub
			items = objects;
			layout = textViewResourceId;
		}
		@Override
		public View getView(int position,View convertView,ViewGroup parentView){
			if(items.get(position).GetFname().length()==1){
				LayoutInflater li = (LayoutInflater)getSystemService(Context.LAYOUT_INFLATER_SERVICE);
				convertView = li.inflate(R.layout.row2, null);
				
				tfname = (TextView)convertView.findViewById(R.id.atxt);
				
				tfname.setText(Character.toString(items.get(position).GetCh()));
			}
			else {
				LayoutInflater li = (LayoutInflater)getSystemService(Context.LAYOUT_INFLATER_SERVICE);
				convertView = li.inflate(R.layout.row, null);
				tfname = (TextView)convertView.findViewById(R.id.fnametxt);
				tlname = (TextView)convertView.findViewById(R.id.lnametxt);
				
				tfname.setText(items.get(position).GetFname());
				tlname.setText("  " + items.get(position).GetLname());
			}
			return convertView;
		}
    	
    }*/
    
	@Override
	 public boolean onCreateOptionsMenu(Menu menu) {
	     MenuInflater inflater = getMenuInflater();
	     inflater.inflate(R.menu.menu_fav, menu);
	     return true;
	 }
	
	@Override
	 public boolean onOptionsItemSelected(MenuItem item) {
	     // Handle item selection
	     switch (item.getItemId()) {
	     
	     case R.id.ref:
	    	 dialog = new ProgressDialog(this);
			 dialog.setMessage("Loading, please wait..");
	    	 Thread fav_th = new Thread(null,DwnFavorites,"Download Favorites");
	    	 fav_th.start();
	         return true;
	     case R.id.set:
	    	 Intent intent = new Intent (this,Search.class);
	    	 startActivity(intent);
	    	 return true;
	     case R.id.quit:
	    	 
	         this.finish();
	         return true;
	     default:
	         return super.onOptionsItemSelected(item);
	     }
	 }
	
	public void ParseList(){
		char currCh = Character.toUpperCase(contacts.get(0).GetCh());
		alphabet = new ArrayList<String>();
		contacts.add(0,new Contact("",Character.toString(currCh),"","","","","","","","",""));
		alphabet.add(Character.toString(Character.toUpperCase(currCh)));
		for(int lv = 2;lv<contacts.size();lv++){
			if(Character.toUpperCase(contacts.get(lv).GetCh())==currCh) continue;
			else {
				currCh = Character.toUpperCase(contacts.get(lv).GetCh());
				contacts.add(lv, new Contact("",Character.toString(currCh),"","","","","","","","",""));
				alphabet.add(Character.toString(Character.toUpperCase(currCh)));
			}
		}
		
		String[] alpha = alphabet.toArray(new String[alphabet.size()]);
		ArrayAdapter<String> aa = new ArrayAdapter<String>(this,R.layout.launch_row,R.id.txt,alpha);
        lv1.setAdapter(aa);
	}

	public void onClick(View v) {
		// TODO Auto-generated method stub
		if(v==add){
			Intent intent = new Intent(this,NewContact.class);
			startActivity(intent);
		}
		else if(v==refresh){
			dialog = new ProgressDialog(v.getContext());
			dialog.setMessage("Loading, please wait..");
			Thread th_refresh = new Thread(null,DoRefresh,"Refresh");
			th_refresh.start();
		}
		else{
			ParseList();
			ca = new ContactAdapter (this,R.layout.row,contacts);
			lv2.setAdapter(ca);
			onStart();
		}
	}

	public void onItemClick(AdapterView<?> arg0, View arg1, int arg2, long arg3) {
		if(arg0==lv1){
			String cl = alphabet.get(arg2);
			for(int lv = 0;lv<contacts.size();lv++){
				if(contacts.get(lv).GetFname().equals(cl)){
					lv2.setSelection(lv);
					break;
				}
			}
		}
		else if (arg0==lv2){
			clicked = arg2;
			Intent intent = new Intent(this,ViewInfo.class);
			Bundle bun = new Bundle();
			ContactList c = new ContactList();
			c.add(contacts.get(arg2));
			bun.putParcelable("Contact", c);
			intent.putExtras(bun);
			startActivity(intent);
		}
	}
	
	private Runnable DoRefresh = new Runnable(){
		public void run(){
			handler.post(RefreshUpdateUI);
			if(favor) Favorites();
			else Refresh();
			handler.post(RefreshUpdateUI);
		}
	};
	private Runnable RefreshUpdateUI = new Runnable(){
		public void run(){
			if(dialog.isShowing()){
				dialog.dismiss();
				ca.notifyDataSetChanged();
				ParseList();
			}
			else dialog.show();
		}
	};
	public void Refresh(){
		UsefulFuncs uf = new UsefulFuncs();
		contacts = uf.DownloadContacts(false,MainActivity.sid);
	}
	
	private Runnable DwnFavorites = new Runnable(){
		public void run(){
			handler.post(FavUpdateUI);
			fvt = true;
			Favorites();
			handler.post(FavUpdateUI);
		}
	};
	private Runnable FavUpdateUI = new Runnable (){
		public void run(){
			if(dialog.isShowing()){
				ca.notifyDataSetChanged();
				dialog.dismiss();
				ParseList();
			}
			else dialog.show();
		}
	};
	public void Favorites(){
		UsefulFuncs uf = new UsefulFuncs();
		contacts = uf.DownloadFavContacts(true, MainActivity.sid);
		//ParseList();
	}
}

