package com.project.contact;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.URI;
import java.net.URISyntaxException;

import org.apache.http.HttpResponse;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;

import android.app.Activity;
import android.app.Dialog;
import android.app.ProgressDialog;
import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.os.Handler;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;

public class ViewInfo extends Activity implements OnClickListener{
	//load phone,cell and email in edittexts
	TextView phone;
	TextView cell;
	TextView mail;
	TextView name;
	
	Boolean returnStatus = false;
	public static Contact conta;
	Button back;
	Button edit;
	Button rmv;
	ProgressDialog dialog;
	Thread th_setfav;
	Handler handler = new Handler();
	Toast toast;
	/** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.showcon);
        
        phone = (TextView)findViewById(R.id.phone);
        cell = (TextView)findViewById(R.id.cell);
        mail = (TextView)findViewById(R.id.mail);
        name = (TextView)findViewById(R.id.name);
        rmv = (Button)findViewById(R.id.rmf);
        
        if(!Screen1.fvt) rmv.setText("Set as Favorite");
        rmv.setOnClickListener(this);
        phone.setOnClickListener(this);
        cell.setOnClickListener(this);
        mail.setOnClickListener(this);
        
        Bundle b = getIntent().getExtras();
        ContactList cl = b.getParcelable("Contact");
        conta = cl.get(0);
        phone.setText(conta.GetPhone());
        cell.setText(conta.GetMobile());
        mail.setText(conta.GetMail());
        name.setText(conta.GetFname()+"  "+conta.GetLname());
        /*
        phone.setText(Screen1.contacts.get(Screen1.clicked).GetPhone());
        cell.setText(Screen1.contacts.get(Screen1.clicked).GetMobile());
        mail.setText(Screen1.contacts.get(Screen1.clicked).GetMail());
        name.setText(Screen1.contacts.get(Screen1.clicked).GetFname()+"  "+Screen1.contacts.get(Screen1.clicked).GetLname());
        */
        back = (Button)findViewById(R.id.back);
        edit = (Button)findViewById(R.id.edit);
        
        toast = Toast.makeText(this,"",Toast.LENGTH_SHORT);
        back.setOnClickListener(this);
        edit.setOnClickListener(this);
    }
    
    
    /*
    public void Click(View v){
    	final AlertDialog alert = new AlertDialog.Builder(v.getContext()).create();
    	alert.setTitle("Option");
    	alert.setContentView(R.layout.option);
    	Button btncall = (Button)alert.findViewById(R.id.call);
    	btncall.setOnClickListener(new View.OnClickListener() {
			
			public void onClick(View v) {
				// TODO Auto-generated method stub
				//Call Intent
				
			}
		});
    	Button btnsms = (Button)alert.findViewById(R.id.sms);
    	btnsms.setOnClickListener(new View.OnClickListener() {
			
			public void onClick(View v) {
				// TODO Auto-generated method stub
				//SMS Intent
				
			}
		});
    	final ImageView btnquit = (ImageView)alert.findViewById(R.id.call);
    	btnquit.setOnClickListener(new View.OnClickListener() {
			
			public void onClick(View v) {
				// TODO Auto-generated method stub
				btnquit.setImageResource(R.drawable.clickedbtn);
				for(int lv = 0; lv<100000 ; lv++){}
				alert.dismiss();
			}
		});
    	alert.show();
    }*/



	public void onClick(View v) {
		// TODO Auto-generated method stub
		if(v==phone || v==cell){
			final Dialog alert = new Dialog(v.getContext());
			//final AlertDialog alert = new AlertDialog.Builder(v.getContext()).create();
	    	alert.setTitle("Option");
	    	alert.setContentView(R.layout.option);
	    	Button btncall = (Button)alert.findViewById(R.id.call);
	    	btncall.setOnClickListener(new View.OnClickListener() {
				
				public void onClick(View v) {
					// TODO Auto-generated method stub
					//Call Intent
					Intent intent = new Intent(Intent.ACTION_CALL);
					if(v==phone)
					 intent.setData(Uri.parse(conta.GetPhone()));
					else intent.setData(Uri.parse(conta.GetMobile()));
					intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
					startActivity(intent);
				}
			});
	    	Button btnsms = (Button)alert.findViewById(R.id.sms);
	    	btnsms.setOnClickListener(new View.OnClickListener() {
				
				public void onClick(View v) {
					// TODO Auto-generated method stub
					//SMS Intent
					Intent sendIntent= new Intent(Intent.ACTION_VIEW);
					 //sendIntent.putExtra("sms_body", "smsBody");
					if(v==phone)
						 sendIntent.setData(Uri.parse(conta.GetPhone()));
					else sendIntent.setData(Uri.parse(conta.GetMobile()));
					sendIntent.setType("vnd.android-dir/mms-sms");
					startActivity(sendIntent);
				}
			});
	    	final ImageView btnquit = (ImageView)alert.findViewById(R.id.cancel);
	    	btnquit.setOnClickListener(new View.OnClickListener() {
				
				public void onClick(View v) {
					// TODO Auto-generated method stub
					btnquit.setImageResource(R.drawable.clickedbtn);
					for(int lv = 0; lv<100000 ; lv++){}
					alert.dismiss();
				}
			});
	    	alert.show();
		}
		else if (v==back) this.finish();
		else if (v==edit){
			Intent intent = new Intent(v.getContext(),EditInfo.class);
			startActivity(intent);
		}
		else if (v==rmv){
			dialog = new ProgressDialog(this);
	        dialog.setMessage("Please wait..");
	        th_setfav = new Thread(null,SetFav,"Setting Favorite");
	        th_setfav.start();
		}
		else{
			//mail to intent
			Intent intent = new Intent(v.getContext(),MailTo.class);
			startActivity(intent);
		}
	}
	private Runnable SetFav = new Runnable(){
		public void run(){
			handler.post(UpdateFavUI);
			handler.post(UpdateFavUI);
		}
	};
	private Runnable UpdateFavUI = new Runnable(){
		public void run(){
			if(dialog.isShowing()){
				dialog.dismiss();
				if(returnStatus){ toast.setText("Operation successful");
				toast.show();}
				else {
					toast.setText("Opertaion unsuccessful");
					toast.show();
				}
			}
			else dialog.show();
		}
	};
	public void SetFavorite(Boolean arg){
		//object.asp?sid={session_id}&method=PERSON_SET_AS_FAVOURITE&select={personid}&remove=1
		String urlstr = "";
		if(!arg)
			urlstr = "https://secure.mydigitalspacelive.com/directory/ondemand/object.asp?sid="+MainActivity.sid+"&method=PERSON_SET_AS_FAVOURITE&select="+conta.GetId()+"&remove=1";
		else urlstr = "https://secure.mydigitalspacelive.com/directory/ondemand/object.asp?sid="+MainActivity.sid+"&method=PERSON_SET_AS_FAVOURITE&select="+conta.GetId(); 
		HttpGet method;
		BufferedReader in = null;
		
		try {
			URI url = new URI(urlstr);
			HttpClient client = new DefaultHttpClient();
			method = new HttpGet(url);
			
			HttpResponse response = client.execute(method);
			in = new BufferedReader 
					(new InputStreamReader(response.getEntity().getContent() ));
			
			//TODO: retrieve the response and prompt user with toast
			String str="";
    		while(in.readLine()==null){
    			str+=in.readLine();
    			if(str.substring(0, 1).equals("OK"))
    				returnStatus = true;
    		}
			}catch(ClientProtocolException e){
				Log.e("ClientProtocolException","Error Occured in fetching videos!" + e.getMessage());
				e.printStackTrace();
			}catch(IOException e){
				Log.e("IOException","Error Occured in fetching videos!"+ e.getMessage());
				e.printStackTrace();
			}catch(URISyntaxException e){
				Log.e("URISyntaxException","Error Occured in fetching videos!"+ e.getMessage());
				e.printStackTrace();
			}
	}
}
